diff -r -u -H -N gcc-2.6.3/combine.c gcc-i2.6.3/combine.c
--- gcc-2.6.3/combine.c	Wed Nov 30 19:13:30 1994
+++ gcc-i2.6.3/combine.c	Wed Feb 15 23:01:12 1995
@@ -10817,4 +10981,2580 @@
     (file,
      "\n;; Combiner totals: %d attempts, %d substitutions (%d requiring new space),\n;; %d successes.\n",
      total_attempts, total_merges, total_extras, total_successes);
+}
+
+/* intel1 */
+/* intel1 - those split insns that remained consecutive should now
+           be combined 
+*/
+void
+combine_unscheded (f, nregs)
+     rtx f;
+     int nregs;
+{
+  register rtx insn, next, prev;
+  register int i;
+  register rtx links, nextlinks, note;
+
+  in_recombine = 1;
+  combine_attempts = 0;
+  combine_merges = 0;
+  combine_extras = 0;
+  combine_successes = 0;
+
+  combine_max_regno = nregs;
+
+  reg_last_death = (rtx *) alloca (nregs * sizeof (rtx));
+  reg_last_set = (rtx *) alloca (nregs * sizeof (rtx));
+  reg_last_set_value = (rtx *) alloca (nregs * sizeof (rtx));
+  reg_last_set_table_tick = (int *) alloca (nregs * sizeof (int));
+  reg_last_set_label = (int *) alloca (nregs * sizeof (int));
+  reg_last_set_invalid = (char *) alloca (nregs * sizeof (char));
+
+  bzero (reg_last_death, nregs * sizeof (rtx));
+  bzero (reg_last_set, nregs * sizeof (rtx));
+  bzero (reg_last_set_value, nregs * sizeof (rtx));
+  bzero (reg_last_set_table_tick, nregs * sizeof (short));
+  bzero (reg_last_set_invalid, nregs * sizeof (char));
+
+  init_recog_no_volatile ();
+
+  /* Compute maximum uid value so uid_cuid can be allocated.  */
+
+  for (insn = f, i = 0; insn; insn = NEXT_INSN (insn))
+    if (INSN_UID (insn) > i)
+      i = INSN_UID (insn);
+
+  uid_cuid = (int *) alloca ((i + 1) * sizeof (int));
+
+  /* Compute the mapping from uids to cuids.
+     Cuids are numbers assigned to insns, like uids,
+     except that cuids increase monotonically through the code. 
+
+     Scan all SETs and see if we can deduce anything about what
+     bits are significant for some registers.  */
+
+  for (insn = f, i = 0; insn; insn = NEXT_INSN (insn))
+    {
+      INSN_CUID (insn) = ++i;
+      if (GET_RTX_CLASS (GET_CODE (insn)) == 'i')
+	note_stores (PATTERN (insn), set_nonzero_bits_and_sign_copies);
+    }
+
+
+  label_tick = 1;
+  last_call_cuid = 0;
+  mem_last_set = 0;
+  /* Now scan all the insns in forward order.  */
+  for (insn = f; insn; insn = NEXT_INSN (insn))
+    {
+      if (GET_CODE (insn) == CODE_LABEL)
+	label_tick++;
+      if(GET_CODE (insn) == INSN)
+	{
+	  /* Try this insn with each insn it links back to.  */
+	  for (links = LOG_LINKS (insn); links; links = XEXP (links, 1))
+	    {
+	      if(REG_NOTE_KIND (links) != REG_DEP_ANTI 
+	         /*&& REG_NOTE_KIND (links) != REG_DEP_OUTPUT 
+	         && */ && (GET_CODE (XEXP (links, 0)) == INSN 
+	              && next_nonnote_insn (XEXP (links, 0))
+	                   == ORG_NEXT_INSN (XEXP (links, 0)))
+	         && GET_CODE (PATTERN (XEXP (links, 0))) == SET
+	         && GET_CODE (SET_DEST (PATTERN (XEXP (links, 0))))
+	              == REG
+	         && (note
+	              = find_regno_note (insn,
+	                                 REG_DEAD,
+	                  REGNO(SET_DEST (PATTERN (XEXP (links, 0))))))
+	         && rtx_equal_p (XEXP (note, 0),
+	                          SET_DEST (PATTERN (XEXP (links, 0))))
+		 /* intel2 - begin */
+		 /* combine only insns that were created by memory_simplify.
+		  */
+		 && (RTX_IS_RISC_P (XEXP (links, 0)))
+		 /* intel2 - end */
+	        )
+	        {
+		  /* intel2 - begin */
+		  rtx inner_link = LOG_LINKS (XEXP (links, 0));
+		  int three_insns = 0;
+
+		  /* Check that we consider the case of three-insns riscified
+		   * insn
+		   */
+		  if (inner_link)
+		    {
+		      for (; inner_link; inner_link = XEXP (inner_link, 1))
+		        {
+		          rtx temp_insn = XEXP (inner_link, 0);
+
+		          if (REG_NOTE_KIND (inner_link) != REG_DEP_ANTI
+		              /*&& REG_NOTE_KIND (inner_link) != REG_DEP_OUTPUT
+		              &&*/ && (GET_CODE (temp_insn) == INSN
+		                  && next_nonnote_insn (temp_insn) ==
+		                  		ORG_NEXT_INSN (temp_insn))
+		              && RTX_IS_RISC_P (temp_insn)
+		              && GET_CODE (PATTERN (temp_insn)) == SET
+		              && GET_CODE (SET_DEST (PATTERN (temp_insn)))
+		                   == REG
+		              && (note
+		                   = find_regno_note (insn,
+		                                      REG_DEAD,
+		                       REGNO(SET_DEST (PATTERN (temp_insn)))))
+		              && rtx_equal_p (XEXP (note, 0),
+		                               SET_DEST (PATTERN (temp_insn)))
+		            )
+		            {
+		              try_combine (insn, XEXP (links, 0), temp_insn);
+		              three_insns = 1;
+		            }
+		        }
+		    }
+
+		  if (! three_insns)
+		    {
+		     /* intel2 - end */
+	             try_combine (insn, XEXP (links, 0), 0);
+	           }
+	        }
+	    }
+	}
+      if(GET_CODE (insn) == INSN ||
+         GET_CODE (insn) == CALL_INSN ||
+         GET_CODE (insn) == JUMP_INSN)
+	  record_dead_and_set_regs (insn);
+    }
+
+  in_recombine = 0;
+
+}
+
+
+
+/* intel2 - begin */
+
+/* we will probably need this - check it and remvoe it if not... */
+
+/*#include "hard-reg-set.h"*/
+
+/* Set of registers that are free and ready to use at this moment.  */
+
+HARD_REG_SET free_regs;
+
+/* Set of registers that are not recommended for allocating at this moment.  */
+
+static HARD_REG_SET not_recommended_regs;
+
+typedef struct {
+  rtx mem;  /* mem rtx, this regno holds */
+  rtx insn_dead;  /* insn in which this regno dies */
+  rtx insn_load;  /* insn in which this regno is loaded */
+  rtx insn_store;  /* insn in which this regno is stored */
+}  MEM_HOLDER;
+
+/* Indexed by regno, indicates which register currently, holds a copy of
+   memory and the rtx represents this memory, as well as the insn loaded it,
+   and the insn in which this register was dead. */
+
+MEM_HOLDER regno_holds_mem[FIRST_PSEUDO_REGISTER];
+/* Perform simplification of memory accessed instructions by replacing them
+   with risc-like instructions.
+   FILE is a file to output debugging information on,
+   or zero if such output is not desired.  */
+
+void
+memory_simplify (file, f)
+     FILE *file;
+     rtx f;
+{
+  register int block, j;
+  int regno, limit;
+  int i; /* intel1 */
+  int nregs; /* intel1 */
+  char * fmt; /* intel1 */
+  MEM_HOLDER *mhp;
+  rtx copy_reg = NULL;
+  rtx t_insn;
+
+  /* record which is the last register used for a spill reload */
+  static int last_load_reg;
+  /* Initialize reg_holds_mem */
+
+  bzero (regno_holds_mem, sizeof regno_holds_mem);
+    
+  /* since all registers now are hard registers, FIRST_PSEUDO_REGISTER is a
+     valid initialization value */
+
+  last_load_reg = FIRST_PSEUDO_REGISTER;
+
+  hard_reg_flow_analysis (f, file, 0 /* no pseudo registers' info. save */ );
+
+  if (n_basic_blocks <= 0)
+    {
+      return ;
+    }
+  /* To determine which registers are live after any insn, start from
+     the beginning of the basic block and scan insns, noting
+     which registers are set by each insn and which die there. */
+  for (block = 0; block < n_basic_blocks; block++)
+    {
+      register rtx insn;
+      int end_of_block_f;
+
+      if (file)
+	fprintf (file, "\nblock number: %d:\n", block);
+
+      last_load_reg = FIRST_PSEUDO_REGISTER;
+      /* since we cannot remove stores before a jump, we clean all the
+         insn_store data */
+
+      for (regno = 0; regno < FIRST_PSEUDO_REGISTER; regno++)
+	regno_holds_mem[regno].insn_store = 0;
+
+      for (regno = 0; regno < FIRST_PSEUDO_REGISTER; regno++)
+        /* at the beginning of a block, each non-live hard register is
+	   considered free. */
+	{
+	  register int offset = regno / REGSET_ELT_BITS;
+	  register int bit = 1 << (regno % REGSET_ELT_BITS);
+	  if (basic_block_live_at_start[block][offset] & bit)
+	    CLEAR_HARD_REG_BIT (free_regs, regno);
+	  else
+	    SET_HARD_REG_BIT (free_regs, regno);
+        }
+
+      /* Traverse the block, an insn by insn, check for memory references,
+	 and find whether a risc-like insns instead are valid. If yes,
+	 replace the insn by another insn(s). */
+
+      end_of_block_f = 0;	/* signals the end of block reached */
+
+      for (insn = basic_block_head[block];
+	   !end_of_block_f;
+	   insn = NEXT_INSN (insn))
+	{
+	  rtx note, next, mem_opr = 0;
+	  rtx pat = PATTERN (insn);
+	  int regno, old_regno;
+	  int saved_code;
+
+	  /* try to eliminate as much stores as we can using the free_regs
+	     and regno_holds_mem information */
+
+	  if (GET_CODE (insn) == INSN
+	      && GET_CODE (pat) == SET
+	      && GET_CODE (SET_DEST (pat)) == MEM
+	      && GET_CODE (SET_SRC (pat)) == REG
+	      && GET_CODE (XEXP (SET_DEST (pat), 0)) != PRE_DEC
+	      && GET_CODE (XEXP (SET_DEST (pat), 0)) != PRE_INC
+	      && GET_CODE (XEXP (SET_DEST (pat), 0)) != POST_DEC
+	      && GET_CODE (XEXP (SET_DEST (pat), 0)) != POST_INC
+	      && (i = remove_redundant_store (SET_DEST (pat), block))
+	      && file)
+	    fprintf (file,
+	             "insn %d caused a deletion of a redundant store: %d\n",
+	                 INSN_UID (insn),
+	                 i);
+
+	  /* Try to eliminate as much loads as we can using the free_regs
+	     and regno_holds_mem information */
+
+	  else if (GET_CODE (insn) == INSN
+		   && GET_CODE (pat) == SET
+		   && (GET_CODE (SET_DEST (pat)) == REG
+		       || GET_CODE (SET_DEST (pat)) == MEM)
+		   && (GET_CODE (SET_SRC (pat)) == MEM
+		       || (GET_CODE (SET_SRC (pat)) == CONST_INT
+		           && flag_risc_const)))
+	    {
+	      int simple_copy_f = 0;
+	      rtx set_src = SET_SRC (pat);
+	      rtx set_dest = SET_DEST (pat);
+	      enum machine_mode mode = GET_MODE (set_dest);
+
+              if (GET_CODE (SET_DEST (pat)) == REG)
+	        old_regno = REGNO (set_dest);
+	      else
+	        old_regno = FIRST_PSEUDO_REGISTER;
+
+	      if (old_regno != FIRST_PSEUDO_REGISTER
+	          && (next = next_nonnote_insn (insn))
+      	          && GET_RTX_CLASS (GET_CODE (next)) == 'i'
+	          && ((note = find_regno_note (next, REG_DEAD, old_regno))
+	              ||
+	              (GET_CODE (PATTERN (next)) == SET && 
+	               rtx_equal_p (set_dest, SET_DEST (PATTERN (next)))))
+	          /* tevid */
+	          && (note == NULL 
+	              || mode == GET_MODE (XEXP (note, 0))))
+	        {
+		  rtx new_reg = NULL;
+	          rtx old_reg = set_dest; 
+	          int stop_replacement = 0;
+
+	          /* if this load is redundant (i.e. the memory loaded
+	             exists in any register, and the register we're loading
+	             to will die in the next insn), we can replace loaded
+	             register in the next insn with the already loaded register,
+	             and delete this insn.
+	          */
+	          if ((regno = find_regno_holds_mem (set_src, mode))
+	          	 				!= FIRST_PSEUDO_REGISTER
+		       && HARD_REGNO_NREGS (regno, mode) == 1
+		       && regno_holds_mem[regno].insn_load
+#ifdef STACK_REGS
+		       && (STACK_REG_P (old_reg)
+			   || NON_STACK_REG_P (new_reg = gen_rtx (REG,
+			      	     mode,
+			      	     regno)))
+
+#endif
+		       && TEST_HARD_REG_BIT (free_regs, regno))
+		    {
+#ifdef STACK_REGS
+                      if (!new_reg)
+		        new_reg = gen_rtx (REG, mode, regno);
+#endif
+
+		      /* replace this register in the next insn */
+                      init_undo_buf ();
+                      saved_code = INSN_CODE (next);
+		      subst_in_insn (next,
+		      		     PATTERN (next),
+		      		     old_reg,
+		      		     new_reg,
+		      		     0,
+		      		     0);
+		      if (note == NULL)
+		        { /* Then the dest of next must remain old_reg */
+		          SET_DEST (PATTERN (next)) = old_reg;
+		        }
+
+#ifdef REGISTER_CONSTRAINTS
+
+	              INSN_CODE (next) = recog (PATTERN (next), next, 0);
+	              if (INSN_CODE (next) != -1)
+		        insn_extract (next);
+
+		      if (INSN_CODE (next) == -1
+		          || !constrain_operands (INSN_CODE (next), 1))
+		        {
+			  /* restore the previous situation */
+			  loop_undo_all();
+			  INSN_CODE (next) = saved_code;
+		          stop_replacement = 1;
+ 		        }
+#endif
+		      if (!stop_replacement)
+		        {
+			      
+			  if (regno != old_regno)
+			    {
+			      if (note != NULL)
+			        {
+			          /* The regno in the REG_DEAD note should be
+			             also changed */
+
+		                  XEXP (note, 0) = new_reg;
+		          
+		                  /* Now, if we replaced a REG_DEAD note, and
+		                     the new_reg is the destination of the next
+		                     insn, we should remove this note */
+
+		                  if (GET_CODE (SET_DEST (PATTERN (next)))
+		                       == REG
+			              && REGNO (SET_DEST (PATTERN (next)))
+			                   == regno)
+		                    remove_death (regno, next);
+		                }	  
+		              /* replace the registers in the free_register
+		                 list */
+
+		              nregs = HARD_REGNO_NREGS (old_regno, mode);
+		              for (i = 0; i < nregs; i++)
+		                SET_HARD_REG_BIT (free_regs, old_regno + i);
+		              nregs = HARD_REGNO_NREGS (regno, mode);
+		              for (i = 0; i < nregs; i++)
+		                CLEAR_HARD_REG_BIT (free_regs, regno + i);
+		            }  /* if (regno != old_regno) */
+		          else
+		          /* regno == old_regno */
+		            {
+		              /* mark that regno is not free anymore */
+		              nregs = HARD_REGNO_NREGS (regno, mode);
+		              for (i = 0; i < nregs; i++)
+		                CLEAR_HARD_REG_BIT (free_regs, regno + i);
+		            }
+
+		          /* now we can delete this insn ... */
+
+		          if (basic_block_head[block] == insn)
+		            basic_block_head[block] = NEXT_INSN (insn);
+
+			  mhp = &regno_holds_mem[regno];
+                          /* we should reset the RISC flag on the insns
+	                     added for risc, so that they will not be
+			     recombined later */
+
+			  
+			  if (mhp -> insn_dead)
+			    {
+			      t_insn = PREV_INSN (mhp->insn_dead);
+			      while (t_insn && RTX_IS_RISC_P (t_insn))
+			        {
+			          RTX_IS_RISC_P (t_insn) = 0;
+			          t_insn = PREV_INSN (t_insn);
+			        }
+			      remove_death (regno, mhp -> insn_dead);
+			      if (! t_insn)
+			        /* something went wrong */
+			        abort ();
+			    }
+
+		          if (file)
+		            fprintf (file,
+		                     "insn %d: deleted - redundant "
+		                     "load encountered (insn %d)\n",
+		                     INSN_UID (insn),
+		                     INSN_UID (mhp -> insn_load));
+		                
+			  PUT_CODE (insn, NOTE);
+		          NOTE_LINE_NUMBER (insn) = NOTE_INSN_DELETED;
+		          NOTE_SOURCE_FILE (insn) = 0;
+
+			  /* ... and start working on the next insn */
+
+		          continue;
+
+		 	}  /* if (!stop_replacement) */
+	              
+		    }  /* if ((regno = find_regno_holds_mem (set_src)) !=
+							   FIRST_PSEUDO_REGISTER
+			           && TEST_HARD_REG_BIT (free_regs, regno)) */
+	             
+		  else if (regno != FIRST_PSEUDO_REGISTER)
+		    /* regno holds the appropriate value but is not free, 
+		       so we can use its contents to
+		       convert this insn to a simple reg to reg copy */
+		    {
+		      copy_reg = gen_rtx (REG, mode, regno);
+#ifdef STACK_REGS
+		      if (GET_CODE (SET_DEST (pat)) != REG
+		          || (STACK_REG_P (SET_DEST (pat))
+                              == STACK_REG_P (copy_reg)))
+#endif
+                        {                  
+		          simple_copy_f = 1;
+		        }
+		    }
+
+	          else if (old_regno == last_load_reg
+			   && (regno =
+			        find_free_reg (GET_MODE (SET_DEST (pat)))) !=
+		               FIRST_PSEUDO_REGISTER
+		           && regno != old_regno)
+	            {
+		      new_reg = gen_rtx (REG, mode, regno);
+
+	              /* replace this insn's register with regno */
+
+	              SET_DEST (pat) = new_reg;
+
+		      /* replace this register in the next insn and its
+		         REG_NOTES */
+		      init_undo_buf ();
+		      saved_code = INSN_CODE (next);
+		      subst_in_insn (next,
+		    		     PATTERN (next),
+		    		     old_reg,
+		    		     new_reg,
+		    		     0,
+		    		     0);
+		      if (note == NULL)
+		       { /* Then the dest of next must remain old_reg */
+		         SET_DEST (PATTERN (next)) = old_reg;
+		       }
+
+#ifdef REGISTER_CONSTRAINTS
+	              if ((INSN_CODE (next) = recog (PATTERN (next),
+							 next,
+							 0)) != -1)
+		        insn_extract (next);
+
+		      if (INSN_CODE (next) == -1
+		          || !constrain_operands (INSN_CODE (next), 1))
+		        {
+			  /* restore the previous situation */
+	                  SET_DEST (pat) = old_reg;
+	                  loop_undo_all ();
+		      	  INSN_CODE (next) = saved_code;
+		          stop_replacement = 1;
+ 		        }
+#endif
+		      if (!stop_replacement)
+		        {
+		          if (note != NULL)
+		            {
+			      /* The regno in the REG_DEAD note should be
+			         changed */
+
+		              XEXP (note, 0) = new_reg;
+		          
+		              /* Now, if we replaced a REG_DEAD note, and the
+		                 new_reg is the destination of the next insn, we
+		                 should remove this note */
+
+		              if (GET_CODE (SET_DEST (PATTERN (next))) == REG
+			          && REGNO (SET_DEST (PATTERN (next))) == regno)
+		                remove_death (regno, next);
+			    }
+		          /* replace the registers in the free_register
+		             list */
+
+		          nregs = HARD_REGNO_NREGS (regno, mode);
+		          for (i = 0; i < nregs; i++)
+		            CLEAR_HARD_REG_BIT (free_regs, regno + i);
+		          nregs = HARD_REGNO_NREGS (old_regno, mode);
+		          for (i = 0; i < nregs; i++)
+		            SET_HARD_REG_BIT (free_regs, old_regno + i);
+
+		          /* replace relevant data in regno_holds_mem */
+		          regno_holds_mem[regno].mem = set_src;
+		          regno_holds_mem[regno].insn_load = insn;
+		          regno_holds_mem[regno].insn_dead = next;
+
+		          if (file)
+		            fprintf (file, 
+		            "insn %d: replacing reload register %d with register %d\n",
+			    INSN_UID (insn), old_regno, regno);
+		 	}  /* if (!stop_replacement) */
+	              
+	            }  /* else if (old_regno == last_load_reg
+			       && (regno =
+				  find_free_reg (GET_MODE (set_dest))) !=
+							  FIRST_PSEUDO_REGISTER)
+			   */
+
+		  else if (old_regno == last_load_reg
+			   && file)
+		    fprintf (file,
+			     "insn %d: no free register found for reload."
+		             "\n", 
+			     INSN_UID (insn));
+
+	        }  /* if ((next = next_nonnote_insn (insn))
+      	                && GET_RTX_CLASS (GET_CODE (next)) == 'i'
+	                && (note = find_regno_note (next, REG_DEAD, old_regno)))
+	               */
+
+	      else if ((regno = find_regno_holds_mem (set_src, mode)) 
+	                != FIRST_PSEUDO_REGISTER
+		        && HARD_REGNO_NREGS (regno, mode) == 1)
+		{
+		  copy_reg = gen_rtx (REG, mode, regno);
+#ifdef STACK_REGS
+		  if (GET_CODE (set_dest) != REG
+		      || (STACK_REG_P (set_dest) == STACK_REG_P (copy_reg)))
+#endif
+                    simple_copy_f = 1;
+	        }
+
+	      if (simple_copy_f)
+		{
+		  MEM_HOLDER *mhp_org;
+		  rtx mem;
+		        
+		  /* we can change this insn to a simple reg copy, instead
+		     of a load or store */
+
+		  mem = SET_SRC (pat);
+		  if (copy_reg == NULL)
+		    {
+		      copy_reg = gen_rtx (REG, mode, regno);
+		    }
+
+		  saved_code = INSN_CODE (insn);
+		  SET_SRC (pat) = copy_reg;
+
+#ifdef REGISTER_CONSTRAINTS
+	          if ((INSN_CODE (insn) = recog (PATTERN (insn),
+						 insn,
+						 0)) != -1)
+		    insn_extract (insn);
+
+		  if (INSN_CODE (insn) == -1
+		      || !constrain_operands (INSN_CODE (insn), 1))
+		    {
+		      SET_SRC (pat) = mem;
+		      INSN_CODE (insn) = saved_code;
+		    }
+		  else
+		    {
+#endif
+
+		      /* now we should eliminate the possibility of the risc
+		         sequence loaded the memory int regno, to be later
+		         recombined */
+
+		      mhp_org = &regno_holds_mem[regno];
+		      mhp = &regno_holds_mem[old_regno];
+		      if (mhp_org -> insn_load)
+			{
+		          /* we should reset the RISC flag on the insns
+		             added for risc, so that they will not be
+		             recombined later */
+
+
+			  if (mhp_org -> insn_dead)
+			    {
+			      t_insn = PREV_INSN (mhp_org->insn_dead);
+			      while (t_insn  && RTX_IS_RISC_P (t_insn))
+			        {
+			          RTX_IS_RISC_P (t_insn) = 0;
+			          t_insn = PREV_INSN (t_insn);
+			        }
+			      if (! t_insn)
+			        fprintf (stderr,
+			                 "Not encountered insn_dead\n");
+			      remove_death (regno, mhp_org -> insn_dead);
+			    }
+			}  /* if (mhp_org -> insn_load) */
+
+		      /* we should update old_regno entries in
+			 regno_holds_mem array */
+
+		      mhp -> mem = mhp_org -> mem;
+		      mhp -> insn_load = insn;
+			  
+		      if (file)
+		        fprintf (file,
+		                 "insn %d: mem source replaced with reg\n",
+		                 INSN_UID (insn));
+
+#ifdef REGISTER_CONSTRAINTS
+		    }  /* else of if (INSN_CODE (insn) == -1
+		                   || !constrain_operands (INSN_CODE (insn), 1))
+		       */
+#endif
+		}  /* if (simple_copy_f) */
+
+              if (GET_CODE (pat) == SET 
+                  && GET_CODE (SET_DEST (pat)) == REG)
+	        last_load_reg = REGNO (SET_DEST (pat));
+
+	    }  /* if (GET_CODE (insn) == INSN
+	                  && GET_CODE (pat) == SET
+	                  && GET_CODE (SET_DEST (pat)) == REG
+	                  && GET_CODE (SET_SRC (pat)) == MEM) */
+
+	  /* mark all the original insns (those not created here). Since
+	     we use here the same bit as RTX_IS_SPILL_P, we should do this
+	     after checking for the spill reload register substitution. */
+	  RTX_IS_RISC_P (insn) = 0;
+
+	  end_of_block_f = (insn == basic_block_end[block]);
+	  if (!INSN_UID (insn))
+	    fatal ("\nMemory simplify: Scanning illegal insn.");
+
+	  if (GET_CODE (insn) == INSN)
+	    {
+	      register rtx note;
+
+	      if (GET_CODE (pat) == SET)
+		{
+		  rtx prev_insn, next_insn;
+		  rtx insn_src = SET_SRC (pat);
+		  rtx insn_dest = SET_DEST (pat);
+		  int mem_opr_is_src = 0;
+
+		  /* indicates which of the two SET_SRC's arguments is a
+		     memory reference. 0 - indicates the first one and 1 -
+		     the second */
+		         
+		  int mem_loc;
+
+		  switch (GET_CODE (insn_src))
+		    {
+		      case CONST_INT:
+		        if (flag_risc_const
+		            && GET_CODE (insn_dest) == MEM
+		            && !push_operand (insn_dest, 
+		                                 GET_MODE (insn_dest)))
+			  {
+			    mem_opr = insn_src;
+			    mem_loc = 1;
+                            mem_opr_is_src = 1;
+			    /* this is a trick to make the code replacing
+			       the memory operand in any other insn, valid
+			       even here.
+			       Note that insn_src now is actually the
+			       insn's pattern, and not the SET_SRC of it. */
+			    insn_src = pat;
+			  }
+                        break;
+		      case REG:
+		      case SYMBOL_REF:
+			/* do nothing, this is a simple copy */
+			break;
+		      case MEM:
+			if (GET_CODE (insn_dest) == CC0)
+			  /* this insn is not a simple load */
+			  {
+			    mem_opr = insn_src;
+			    mem_loc = 1;
+
+                            mem_opr_is_src = 1;
+			    /* this is a trick to make the code replacing
+			       the memory operand in any other insn, valid
+			       even here.
+			       Note that insn_src now is actually the
+			       insn's pattern, and not the SET_SRC of it. */
+			    insn_src = pat;
+			  }
+			break;
+		      default:
+		        if (GET_CODE (insn_src) == SIGN_EXTRACT
+		            || GET_CODE (insn_src) == ZERO_EXTRACT)
+		          { /* These cannot be handled properly */
+		            break;
+		          }
+			fmt = GET_RTX_FORMAT (GET_CODE (insn_src));
+			if (GET_CODE (XEXP (insn_src, 0)) == MEM)
+			  {
+			    mem_loc = 0;
+			    mem_opr = XEXP (insn_src, 0);
+			  }
+			else if (GET_RTX_LENGTH (GET_CODE (insn_src)) > 1
+				 && fmt[1] == 'e'
+				 && GET_CODE (XEXP (insn_src, 1)) == MEM)
+			  {
+			    mem_loc = 1;
+			    mem_opr = XEXP (insn_src, 1);
+			  }
+			break;
+		    }	/* switch (GET_CODE(insn_src)) */
+
+		  if (mem_opr)
+		    /* we found a memory operand that we should replace */
+		    {
+		      int skip_load_f = 0;  /* should we skip mem load? */
+		      int regno_is_free = 0; /* was it allocated by find_free_reg */
+		      int memory_dest_changed  
+			      		 = GET_CODE (insn_dest) == MEM
+			      		    && rtx_equal_p (insn_dest, mem_opr);
+		      enum machine_mode mode = GET_MODE (mem_opr);
+
+                      if (GET_CODE (mem_opr) == CONST_INT)
+                        mode = GET_MODE (insn_dest);
+		      if ((regno = find_regno_holds_mem (mem_opr, mode)) 
+		           != FIRST_PSEUDO_REGISTER)
+			{
+			  if (HARD_REGNO_NREGS (regno, mode) == 1
+			      && TEST_HARD_REG_BIT (free_regs, regno))
+			    skip_load_f = 1;
+			  else
+			    regno = FIRST_PSEUDO_REGISTER;
+			}
+                      if (regno == FIRST_PSEUDO_REGISTER
+#ifdef IS_RISC_MODE
+		          && (IS_RISC_MODE (GET_MODE (mem_opr))
+		              || GET_CODE (mem_opr) == CONST_INT)
+#endif
+                         )
+                        { /* Look forward a few insns to see
+                             if this mem_opr will be loaded
+                             into a register and if it is then
+                             try to use that register for riscifying.  */
+                          t_insn = next_nonnote_insn (insn);
+                          while (t_insn && regno == FIRST_PSEUDO_REGISTER)
+                            {
+                              if (GET_CODE (t_insn) == CODE_LABEL
+                                  || GET_CODE (t_insn) == CALL_INSN)
+                                {
+                                  break;
+                                }
+                              if (GET_CODE (t_insn) == INSN)
+                                {
+                                  register rtx dest;
+                                  
+                                  if (GET_CODE (PATTERN (t_insn)) != SET)
+                                    {
+                                      break;
+                                    }
+                                  dest = SET_DEST (PATTERN (t_insn));
+                                  if (GET_CODE (dest) == REG
+                                      && rtx_equal_p (mem_opr,
+                                          SET_SRC (PATTERN (t_insn))))
+                                    {
+                                      regno = REGNO (dest);
+			              nregs = HARD_REGNO_NREGS (regno, mode);
+			              if (HARD_REGNO_MODE_OK (regno, mode))
+			                {
+			                  for (i = 0; i < nregs; i++)
+			                    if (! TEST_HARD_REG_BIT (free_regs,
+			            			          regno + i))
+			                      {
+			                        regno = FIRST_PSEUDO_REGISTER;
+			                        break;
+			                      }
+			                }
+			              else
+			                regno = FIRST_PSEUDO_REGISTER;
+                                    }
+                                  else if (GET_CODE (dest) == MEM
+                                           && ! push_operand (dest,
+                                           		      GET_MODE (dest)))
+                                    /* since there is a write to memory, no use
+                                       in trying to load something that might be
+                                       clobbered. */
+			            regno = FIRST_PSEUDO_REGISTER;
+                                }
+                              t_insn = next_nonnote_insn (t_insn);
+                            }
+                                     
+                        }
+                      if (regno == FIRST_PSEUDO_REGISTER
+			  && GET_CODE (insn_dest) == REG
+#ifdef IS_RISC_MODE
+		          && (IS_RISC_MODE (GET_MODE (mem_opr))
+		              || GET_CODE (mem_opr) == CONST_INT)
+#endif
+                         )
+			{
+			  regno = REGNO (insn_dest);
+			  nregs = HARD_REGNO_NREGS (regno, mode);
+
+			  if (HARD_REGNO_MODE_OK (regno, mode))
+			    {
+			      for (i = 0; i < nregs; i++)
+			        if (! TEST_HARD_REG_BIT (free_regs,
+			        			 regno + i))
+			          {
+			            regno = FIRST_PSEUDO_REGISTER;
+			            break;
+			          }
+			    }
+			  else
+			    regno = FIRST_PSEUDO_REGISTER;
+			}
+
+	              if (regno == FIRST_PSEUDO_REGISTER
+#ifdef IS_RISC_MODE
+		          && (IS_RISC_MODE (GET_MODE (mem_opr))
+		              || GET_CODE (mem_opr) == CONST_INT)
+#endif
+                         )
+			{
+			  prev_insn = prev_nonnote_insn (insn);
+			  next_insn = next_nonnote_insn (insn);
+
+			  /* update set of not recommended hard registers
+			     for find_free_reg () */
+			  /* NOTE that we can refer only to integer
+			     registers, but now we do it more general. */
+
+			  for (regno = 0;
+			       regno < FIRST_PSEUDO_REGISTER;
+			       regno++)
+
+			    if ((prev_insn
+			         && GET_RTX_CLASS (GET_CODE (prev_insn))
+						  == 'i'
+			         && (INSN_USES_REGNO (prev_insn, regno)
+				     || INSN_SETS_REGNO (prev_insn, regno)))
+				     || (next_insn
+				        && GET_RTX_CLASS (GET_CODE (next_insn))
+									  == 'i'
+				 && (INSN_USES_REGNO (next_insn, regno)
+			         /* If the destination is MEM we
+			            might write the new register
+			            contents to the memory as the
+			            last insn. This will force us to
+			            also consider a write to the
+			            allocated register in the next
+			            insn. */
+
+				  || (memory_dest_changed
+				      && INSN_SETS_REGNO (next_insn,
+				                          regno)))))
+			      SET_HARD_REG_BIT (not_recommended_regs,regno);
+			    else
+			      CLEAR_HARD_REG_BIT (not_recommended_regs,
+			      		      regno);
+
+			  regno = find_free_reg (mode);
+			  regno_is_free = 1;
+			}
+
+	              if (regno != FIRST_PSEUDO_REGISTER)
+			{
+			  rtx new_insn, new_reg, link;
+
+			  /* before changing the insn, and adding others, we
+			     check the changed insn will be legal. */
+
+			  new_reg = gen_rtx (REG, mode, regno);
+			  saved_code = INSN_CODE (insn);
+			  if (mem_opr_is_src)
+			    {
+			      SET_SRC (pat) = new_reg;
+			    }
+			  else
+			    {
+                              init_undo_buf ();
+			      subst_in_insn (insn, pat, mem_opr, new_reg, 0, 0);
+			    }
+			      
+#ifdef REGISTER_CONSTRAINTS
+			  /* now check if the insn's O.K. */
+
+			  INSN_CODE (insn) = recog (pat, insn, 0);
+
+			  if (INSN_CODE (insn) != -1)
+			    insn_extract (insn);
+
+			  if (INSN_CODE (insn) == -1
+			      || ! constrain_operands (INSN_CODE (insn), 1))
+		            {
+			      if (mem_opr_is_src)
+			        {
+			          SET_SRC (pat) = mem_opr;
+			        }
+			      else
+			        {
+			          loop_undo_all ();
+			        }
+			      INSN_CODE (insn) = saved_code;
+			    }
+			  else  /* the replacement is valid */
+			    {
+#endif
+			      if (! skip_load_f)
+			        {
+
+			          if (mode != SImode && regno_is_free
+			              && GET_CODE (mem_opr) == CONST_INT)
+			            {
+			              new_reg = gen_rtx (REG, SImode, regno);
+			            }
+			          /* load the memory into regno */
+			          new_insn 
+			           = make_insn_raw (gen_rtx (SET,
+							     VOIDmode,
+							     new_reg,
+							      mem_opr));
+
+				  RTX_IS_RISC_P (new_insn) = 1;
+			          add_insn_after (new_insn,
+						  PREV_INSN (insn));
+
+				  /* record regno as the last register that
+				    is used for loading */
+			      
+				  last_load_reg = regno;
+
+
+				  /* update new data in regno_holds_mem[] */
+				      
+#if 0
+				  mhp = &regno_holds_mem[regno];
+				  mhp -> insn_load = new_insn;
+#endif
+				  update_regno_holds_mem(new_insn,
+				    	     PATTERN(new_insn));
+				      
+				  /* if insn was the first insn in this
+				     block this should be updated */
+
+				  if (basic_block_head[block] == insn)
+				    basic_block_head[block] = new_insn;
+
+				  if (file)
+				    {
+					fprintf (file, "insn %d was added ",
+						   INSN_UID (new_insn));
+					fprintf (file, "before insn %d\n",
+						       INSN_UID (insn));
+				    }
+
+				  /* move the insn's LOG_LINKS to new_insn */
+				  LOG_LINKS (new_insn) = LOG_LINKS (insn);
+				  LOG_LINKS (insn) = 0;
+
+				  /* move all relevant REG_DEAD notes to
+				     new_insn */
+				  for (note = REG_NOTES (insn);
+				       note;
+				       note = XEXP (note, 1))
+				    {
+				      if (REG_NOTE_KIND (note) == REG_DEAD)
+					{
+					  register int regno 
+					    = REGNO (XEXP (note, 0));
+
+					  if (GET_RTX_LENGTH (
+					  	GET_CODE (insn_src)) < 2
+					        || GET_CODE (XEXP (insn_src,
+					      	     1 - mem_loc))
+					      	     != REG
+					       || REGNO (XEXP (insn_src,
+							 1 - mem_loc))
+							!= regno)
+					    {
+					          
+					      /* this note does not refer to
+					         the register that will be
+					         used from now on within
+					         insn, thus we move it to
+					        new_insn. */
+
+					      remove_note (insn, note);
+					      mhp = &regno_holds_mem[regno];
+					      REG_NOTES (new_insn) =
+					      gen_rtx (EXPR_LIST,
+							REG_DEAD,
+							XEXP (note, 0),
+							REG_NOTES(new_insn));
+					      mhp -> insn_dead = new_insn;
+
+					      SET_HARD_REG_BIT
+						       (free_regs,
+						        REGNO (XEXP (note, 0)));
+					    }
+					}  /* if (REG_NOTE_KIND (note) == REG_DEAD) */
+				    }  /* for (note = REG_NOTES (insn);
+					           note;
+					           note = XEXP (note, 1)) */
+				}  /* if (! skip_load_f) */
+		              else
+				/* we use an already loaded register */
+				{
+
+				  /* since we use a load for a possibly 
+				     previously riscified insn, we should
+				     unmark the insns created for that insn,
+				     so that recombine will not try to
+				     delete its load */
+				  mhp = &regno_holds_mem[regno];
+				  if (mhp -> insn_dead)
+				    {
+				      /* we should reset the RISC flag on
+				         the insns added for risc, so that
+				         they will not be recombined later
+				      */
+
+				      t_insn = PREV_INSN (mhp -> insn_dead);
+				      while (t_insn && RTX_IS_RISC_P (t_insn))
+					{
+					   RTX_IS_RISC_P (t_insn) = 0;
+					   t_insn = PREV_INSN (t_insn);
+					}
+			              remove_death (regno, mhp->insn_dead);
+			            }  /* if (mhp -> insn_load) */
+
+				  if (file)
+				    {
+				      fprintf (file, "insn %d: changed mem ",
+							   INSN_UID (insn));
+				      fprintf (file, "operand with already "
+							   "loaded register %d\n",
+							   regno);
+				    }
+				}
+
+		              /* in the case the memory operand was also the
+				 insn's destination, we should add an insn
+				 to store the result, now stored in
+				 new_reg. */
+
+		              if (memory_dest_changed)
+			        {
+			          /* Since memory destination was replaced by
+			             a register, its contents is clobbered */
+
+#if 0
+				  regno_holds_mem[regno].mem = 0;
+#endif
+				  bzero (&regno_holds_mem[regno],
+				         sizeof (MEM_HOLDER));
+				  update_entries (new_reg);
+
+				  new_insn = make_insn_raw (pat);
+
+				  RTX_IS_RISC_P (new_insn) = 1;
+				  add_insn_after (new_insn,
+					          PREV_INSN (insn));
+
+				  if (skip_load_f
+				      && basic_block_head[block] == insn)
+				    basic_block_head[block] = new_insn;
+
+				  if (file
+				      && ! skip_load_f)
+				    {
+				      fprintf (file, "insn %d was also ",
+					       INSN_UID (new_insn));
+				      fprintf (file, "added before insn ");
+				      fprintf (file, "%d\n",
+					  		INSN_UID (insn));
+				    }
+				  else if (file)
+				    {
+				    fprintf (file,
+				             "insn %d was added before "
+				             "insn %d, load was saved\n",
+				             INSN_UID (new_insn),
+				             INSN_UID (insn));
+				   }
+
+
+				  /* change insn to be just a store insn */
+				  PATTERN (insn) = gen_rtx (SET,
+								VOIDmode,
+								mem_opr,
+								new_reg);
+
+				  /* now we might find that a previous
+				     store is redundant... */
+				  if ((i = remove_redundant_store (mem_opr,
+								   block))
+				       && file)
+				    {
+				    fprintf (file,
+				             "insn %d: caused deletion of "
+				             "a redundant store: %d\n",
+				             INSN_UID (insn),
+				             i);
+				    }
+
+				  /* now we actually changed the insn's
+				     code, so we erase the current one and
+				     we let next phases (probably sched2) to
+				     update this code. */
+
+				  INSN_CODE (insn) = -1;
+
+				  if (! skip_load_f)
+				    {
+				      /* add the last_new_insn to the new_insn's
+					 dependency list */
+
+				      link = rtx_alloc (INSN_LIST);
+				      PUT_REG_NOTE_KIND (link, 0);
+				      XEXP (link, 0) = PREV_INSN (new_insn);
+				      XEXP (link, 1) = LOG_LINKS (new_insn);
+				      LOG_LINKS (new_insn) = link;
+				    }
+				}	/* if (memory_dest_changed) */
+
+		              /* add the new_insn to the insn's dependency
+				 list */
+
+		              if (! skip_load_f
+				  || memory_dest_changed)
+				{
+				  link = rtx_alloc (INSN_LIST);
+				  PUT_REG_NOTE_KIND (link, 0);
+				  XEXP (link, 0) = new_insn;
+				  XEXP (link, 1) = LOG_LINKS (insn);
+				  LOG_LINKS (insn) = link;
+				}
+
+				  /* Add a REG_DEAD note to the last insn to
+				     indicate that the used register is no
+				     longer needed.
+				     This is not needed for this phase since we
+				     do not remove this register from the free
+				     register list (we just mark it to indicate
+				     that next allocation of free register, will
+				     not return it again, so that dependency
+				     between adjacent insns will be as less as
+				     possible). */
+
+			      if (GET_CODE (insn_dest) != REG
+				  || REGNO (insn_dest) != REGNO (new_reg))
+		              {
+				REG_NOTES (insn) 
+				  = gen_rtx (EXPR_LIST,
+					     REG_DEAD,
+					     new_reg, 
+					     REG_NOTES (insn));
+		              }
+#ifdef REGISTER_CONSTRAINTS
+		            }  /* the replacement is valid */
+#endif
+			}  /* if (regno != FIRST_PSEUDO_REGISTER) */
+		      else if (file)
+			{
+			        fprintf (file, "insn %d: No suitable free hard",
+			      				       INSN_UID (insn));
+			        fprintf (file, " register found for risc\n");
+			}
+		    }  /* if (mem_opr) */
+		}  /* if (GET_CODE (pat) == SET) */
+            }  /* if (GET_CODE(insn) == INSN) */
+
+	  if (GET_CODE (insn) == CODE_LABEL)
+	    bzero (regno_holds_mem, sizeof regno_holds_mem);
+
+	  if (GET_RTX_CLASS (GET_CODE (insn)) == 'i')
+	    {
+
+	      if (GET_CODE (insn) == CALL_INSN)
+	        {
+		   /* all call clobbered registers are now free */
+
+		   for (j = 0; j < FIRST_PSEUDO_REGISTER; j++)
+		     if (call_used_regs[j])
+		          SET_HARD_REG_BIT (free_regs, j);
+	        }
+
+	      update_free_regs (PATTERN (insn));
+
+	      update_regno_holds_mem (insn, PATTERN (insn));
+
+	      /* add each dead register to the free_regs set */
+	      /* mark each dead regno in the regno_holds_mem array */
+	      for (note = REG_NOTES (insn); note; note = XEXP (note, 1))
+	        {
+		  if ((REG_NOTE_KIND (note) == REG_DEAD
+		       || REG_NOTE_KIND (note) == REG_UNUSED)
+		      && GET_CODE (XEXP (note, 0)) == REG)
+		    {
+		      regno = REGNO (XEXP (note, 0));
+		      nregs = 
+		        HARD_REGNO_NREGS (regno, GET_MODE (XEXP (note, 0)));
+  
+		      for (i = 0; i < nregs; i++)
+		        SET_HARD_REG_BIT (free_regs, regno + i);
+		      regno_holds_mem[regno].insn_dead = insn;
+		    }
+		}
+	      if ((note = find_reg_note (insn, REG_WAS_0, 0)))
+	        {
+	          rtx set;
+	          set = single_set (insn);
+	          if (set == NULL 
+		      || GET_CODE (SET_DEST (set)) == REG)
+	            { /* Since reg may have been reused.  */
+		      remove_note (insn, note);
+	            }
+	        }
+	    }  /* if (GET_RTX_CLASS (GET_CODE (insn)) == 'i') */
+	}  /* for (insn = basic_block_head[block]; */
+    }  /* for (block = 0; block < n_basic_blocks; block++) */
+
+    /* mark each insn with it's next nonnote insn so that recombine can work */
+    {
+
+      t_insn = f;
+      while (t_insn)
+        {
+          if (GET_CODE (t_insn) == INSN)
+            ORG_NEXT_INSN (t_insn) = next_nonnote_insn (t_insn);
+          t_insn = NEXT_INSN (t_insn);
+        }
+    }
+}				/* memory_simplify (file, f) */
+
+
+static void
+dump_free_registers (file)
+     FILE *file;
+{
+  register int regno;
+
+  fprintf (file, "Free registers now are: ");
+  for (regno = 0; regno < FIRST_PSEUDO_REGISTER; regno++)
+    if (TEST_HARD_REG_BIT (free_regs, regno))
+      {
+	fprintf (file, " %d", regno);
+      }
+  fprintf (file, "\n");
+}
+
+/*  Finds a free register that is able to contain a value of mode MODE.
+ *  Returns the number of the hard register (or the first hard register, in
+ *  case of multi-register value) found, if such exists, and mark it in the
+ *  regs_ever_live array. Otherwise returns  FIRST_PSEUDO_REGISTER.
+ */
+
+int
+find_free_reg (mode)
+     enum machine_mode mode;
+{
+  register int regno;
+
+  /* record last_reg retunrned. Try next find form this reg on. */
+  static int last_reg;
+
+  int not_desired;		/* is this the "not-desired" regset: i.e. are we going to
+            * take the register from those who are not "safe" within
+            * a function (their values is promised not to be altered).
+            */
+  int second_half;		/* is this the second half of the "round-robin" search */
+
+#ifdef IS_RISC_MODE
+  if (!IS_RISC_MODE (mode))
+    {
+      return (FIRST_PSEUDO_REGISTER);
+    }
+#endif
+  /* we handle only DImode SImode, HImode and QImode */
+  switch (mode)
+    {
+    case DImode:
+    case SImode:
+    case HImode:
+    case QImode:
+
+      /* Try to find the register among those whos value is not "safe"
+       * first.
+       */
+      for (not_desired = 0; not_desired < 2; not_desired++)
+	{
+	  int last_reg_scanned = 0;
+
+	  /* implement a "round-robin" algorithm for register scanning.
+	     fisrt look from the last_reg and on, and then from 0 to
+	     last_reg. */
+	     
+	  for (regno = (last_reg + 1) % FIRST_PSEUDO_REGISTER;
+	       ! last_reg_scanned;
+	       regno = (regno + 1) % FIRST_PSEUDO_REGISTER)
+	    {
+	      register int i, nregs = HARD_REGNO_NREGS (regno, mode);
+	      register int found = 1;
+
+	      last_reg_scanned = last_reg == regno;
+	      for (i = 0; i < nregs; i++)
+	        {
+	          if (! not_desired
+		      && (! call_used_regs[regno + i]
+			  || TEST_HARD_REG_BIT (not_recommended_regs,
+			  			regno + i)))
+		    found = 0;
+	          else if (! fixed_regs[regno + i]
+	            	   && TEST_HARD_REG_BIT (free_regs, regno + i)
+	            	   && HARD_REGNO_MODE_OK (regno + i, mode)
+#ifdef ELIMINABLE_REGS
+			   && (! frame_pointer_needed
+			       || regno != FRAME_POINTER_REGNUM)
+#endif
+			   /* allow only registers that lived before this
+			      phase to take part. This might reduce the number
+			      of registers available, but otherwise some
+			      problems may occur due to use of a register that
+			      need to be pushed at the the function prologue,
+			      thus corrupting the calculations of stack slots
+			      previously performed at the reload phase. */
+			   && (call_used_regs[regno + i]
+			       || regs_ever_live[regno + i])
+			  )
+		    continue;
+		  else
+			found = 0;
+		}  /* for (i = 0; i < nregs; i++) */
+	      if (found)
+		{
+		  /* save regno for the next invokation */
+		  last_reg = regno + nregs - 1;
+
+		  return (regno);
+		}
+	    } /* for (regno = (last_reg + 1) % FIRST_PSEUDO_REG;
+	         regno != last_reg;
+	         regno = (regno + 1) % FIRST_PSEUDO_REG) */
+	}  /* for (not_desired = 0; not_desired < 2; not_desired ++) */
+      break;
+    }  /* switch (mode) */
+  return (FIRST_PSEUDO_REGISTER);
+}
+
+/* Updates the free_regs regset according the contents of PAT */
+
+void
+update_free_regs (rtx pat)
+{
+  register int i, regno, nregs;
+  register j;
+  register char *fmt;
+  register RTX_CODE code = GET_CODE (pat);
+
+  switch (code)
+    {
+      case SET:
+      case USE:
+      case CLOBBER:
+        if (GET_CODE (SET_DEST (pat)) == REG)
+          {
+            regno = REGNO (SET_DEST (pat));
+            nregs = HARD_REGNO_NREGS (regno,
+            					   GET_MODE (SET_DEST (pat)));
+
+            if (GET_CODE (pat) == SET
+                || GET_CODE (pat) == USE)
+              for (i = 0; i < nregs; i++)
+                CLEAR_HARD_REG_BIT (free_regs, regno + i);
+#if 0
+            else /* GET_CODE (pat) == CLOBBER */
+              for (i = 0; i < nregs; i++)
+                SET_HARD_REG_BIT (free_regs, regno + i);
+#endif
+          }
+        else if (GET_CODE (SET_DEST (pat)) == SUBREG
+                 && GET_CODE (SUBREG_REG (SET_DEST (pat))) == REG)
+          {
+            regno = REGNO (SUBREG_REG (SET_DEST (pat))) 
+                         + SUBREG_WORD (SET_DEST (pat));
+            nregs = HARD_REGNO_NREGS (regno,
+            					   GET_MODE (SET_DEST (pat)));
+
+            if (GET_CODE (pat) == SET
+                || GET_CODE (pat) == USE)
+              for (i = 0; i < nregs; i++)
+                CLEAR_HARD_REG_BIT (free_regs, regno + i);
+          }
+        break;
+      case ADDR_VEC:
+      case CALL:
+      case HIGH:
+      case CONST_INT:
+      case CONST:
+      case CONST_DOUBLE:
+      case SYMBOL_REF:
+      case LABEL_REF:
+      case PC:
+      case CC0:
+      case REG:
+        /* do nothing */
+        return;
+   }  /* switch (GET_CODE (pat)) */
+
+  fmt = GET_RTX_FORMAT (code);
+  for (i = GET_RTX_LENGTH (code) - 1; i >= 0; i--)
+    if (fmt[i] == 'e')
+      {
+        if( XEXP (pat, i))
+          update_free_regs (XEXP (pat, i));
+      }
+    else if (fmt[i] == 'E' || fmt[i] == 'V')
+      {
+	for (j = 0; j < XVECLEN (pat, i); j++)
+	  update_free_regs (XVECEXP (pat, i, j));
+      }
+}
+
+#if 0
+/* Returns a hard register regno, if the contents of entry regno in
+   last_reloads array equals to MEM, FIRST_PSEUDO_REGISTER otherwise. */
+
+static int
+find_last_reload (rtx mem)
+{
+  register int regno;
+  
+  if (GET_CODE (mem) != MEM)
+    abort ();
+
+  for (regno = 0; regno < FIRST_PSEUDO_REGISTER; regno++)
+    if (rtx_equal_p (LAST_RELOAD (regno), mem))
+      return (regno);
+
+  return (FIRST_PSEUDO_REGISTER);
+}
+#endif
+
+/* Returns regno of a free register holding MEM, or FIRST_PSEUDO_REGISTER if
+   not exist such register. */
+
+static int
+find_regno_holds_mem (rtx mem, enum machine_mode mode)
+{
+  int i, is_const;
+  MEM_HOLDER *mhp;
+
+  is_const = GET_CODE (mem) == CONST_INT;
+  
+  for (mhp = regno_holds_mem;
+       mhp < regno_holds_mem + FIRST_PSEUDO_REGISTER;
+       mhp++)
+    {
+      if (mhp->mem && GET_CODE (mhp->insn_load) == NOTE)
+        { /* was deleted */
+          mhp->insn_load = NULL;
+          mhp->mem = NULL;
+          mhp->insn_dead = NULL;
+        }
+      if (mhp->insn_store && GET_CODE (mhp->insn_store) == NOTE)
+        { /* was deleted */
+          mhp->insn_store = NULL;
+        }
+#if 0
+      if ((mhp->insn_load 
+           && mhp->mem
+#endif
+      if ((mhp->mem
+           && GET_CODE (mhp -> mem) == GET_CODE (mem)
+           && (is_const 
+                ? rtx_equal_p ( (mhp -> mem), (mem))
+                : rtx_equal_p (XEXP (mhp -> mem, 0), XEXP (mem, 0)))
+           && HARD_REGNO_MODE_OK (mhp - regno_holds_mem, mode)
+           && GET_MODE_SIZE (GET_MODE (SET_DEST (PATTERN (mhp -> insn_load))))
+               >= GET_MODE_SIZE (mode))
+	  || (mhp -> mem
+	      && mhp -> insn_store
+              && GET_MODE_SIZE (GET_MODE (SET_SRC (PATTERN (mhp -> insn_store))))
+                   >= GET_MODE_SIZE (mode)
+              && GET_CODE (SET_DEST ( PATTERN (mhp -> insn_store))) 
+                   == GET_CODE (mem)
+              && HARD_REGNO_MODE_OK (mhp - regno_holds_mem, mode)
+              && (is_const
+                  ? rtx_equal_p (SET_DEST ( PATTERN (mhp -> insn_store)), 
+                                 mem)
+                  : rtx_equal_p (XEXP (SET_DEST (PATTERN (mhp -> insn_store)),
+                  		       0),
+                                 XEXP (mem, 0)))))
+        return (mhp - regno_holds_mem);
+    }
+  return FIRST_PSEUDO_REGISTER;
+}  /* find_regno_holds_mem (rtx mem) */
+
+
+
+/* Updates the regno_holds_mem array as required from pat */
+
+static void
+update_regno_holds_mem (rtx insn, rtx pat)
+{
+  register int i, j, regno, nregs;
+  MEM_HOLDER *mhp;
+  rtx set_src, set_dest;
+  register char *fmt;
+  register RTX_CODE code = GET_CODE (pat);
+
+  if (GET_CODE (insn) == JUMP_INSN)
+    {
+      for (i = 0; i < FIRST_PSEUDO_REGISTER; i++)
+        regno_holds_mem[i].insn_store = 0;
+      return;
+    }
+
+  switch (GET_CODE (pat))
+    {
+      case SET:
+        set_src = SET_SRC (pat);
+        set_dest = SET_DEST (pat);
+        if (GET_CODE (set_dest) == REG)
+          {
+            regno = REGNO (set_dest);
+            nregs = HARD_REGNO_NREGS (regno, GET_MODE (set_dest));
+
+            mhp = &regno_holds_mem[regno];
+            if (nregs == 1
+                && (GET_CODE (set_src) == MEM
+                    && !MEM_VOLATILE_P (set_src)
+                    && GET_CODE (XEXP (set_src, 0)) != PRE_INC
+                    && GET_CODE (XEXP (set_src, 0)) != PRE_DEC
+                    && GET_CODE (XEXP (set_src, 0)) != POST_INC
+                    && GET_CODE (XEXP (set_src, 0)) != POST_DEC)
+                   || GET_CODE (set_src) == CONST_INT)
+              {
+                mhp -> mem = set_src;
+                mhp -> insn_load = insn;
+                mhp -> insn_store = mhp -> insn_dead = 0;
+              }
+            else
+              {
+                for (; mhp < &regno_holds_mem[regno] + nregs; mhp++)
+                  {
+                    bzero (mhp, sizeof (MEM_HOLDER));
+                  }
+              }
+            if (nregs == 1)
+              {
+                /* since we set a register, each mem using this reg is not valid
+                   any more */
+
+                update_entries (set_dest);
+              }
+            else
+              {
+                /* memory holds more than one register. This is a simplification
+                   Actually we should zero only those register entries which are
+                   relevant for nregs... */
+                bzero (regno_holds_mem, sizeof regno_holds_mem);
+                break;
+              }
+            update_regno_holds_mem (insn, set_src);
+          }
+        else if (GET_CODE (set_dest) == SUBREG)
+          {
+            if (GET_CODE (SUBREG_REG (set_dest)) == REG)
+              {
+                regno = REGNO (SUBREG_REG (set_dest)) + SUBREG_WORD (set_dest);
+                nregs 
+                  = HARD_REGNO_NREGS (regno, GET_MODE (SUBREG_REG (set_dest)));
+
+                mhp = &regno_holds_mem[regno];
+                for (; mhp < &regno_holds_mem[regno] + nregs; mhp++)
+                  {
+                    bzero (mhp, sizeof (MEM_HOLDER));
+                  }
+                if (nregs == 1)
+                  {
+                    update_entries (SUBREG_REG (set_dest));
+                  }
+                else
+                  {
+                    /* memory holds more than one register. This is a simplification.
+                       Actually we should zero only those register entries which are
+                       relevant for nregs... */
+                    bzero (regno_holds_mem, sizeof regno_holds_mem);
+                  }
+                update_regno_holds_mem (insn, set_src);
+                return;
+              }
+            else /* subreg of mem */
+              {
+	        for (i = 0; i < FIRST_PSEUDO_REGISTER; i++)
+	          regno_holds_mem[i].mem = 0;
+                update_regno_holds_mem (insn, XEXP (XEXP (set_dest, 0), 0));
+                update_regno_holds_mem (insn, set_src);
+                return;
+              }
+          }
+        else if (GET_CODE (set_dest) == MEM)
+          {
+	    MEM_HOLDER save_mh;
+	    int is_push = 0;
+
+	    mhp = 0;
+
+            if ((GET_CODE (set_src) == REG
+                 || GET_CODE (set_src) == CONST_INT)
+                && push_operand (set_dest, Pmode))
+              { /* A push only ruins memory references based on stack_pointer */
+                is_push = 1;
+              }
+            else if (GET_CODE (set_src) == REG
+                /* We might want to add the possibility of SUBREG, isn't it? */
+                && !MEM_VOLATILE_P (set_dest)
+                && GET_CODE (XEXP (set_dest, 0)) != PRE_INC
+                && GET_CODE (XEXP (set_dest, 0)) != PRE_DEC
+                && GET_CODE (XEXP (set_dest, 0)) != POST_INC
+                && GET_CODE (XEXP (set_dest, 0)) != POST_DEC)
+              {
+                register int regno = REGNO (set_src);
+                register int nregs = HARD_REGNO_NREGS (regno,
+                				       GET_MODE (set_src));
+
+                if (nregs == 1)
+                  {
+                    mhp = &regno_holds_mem[regno];
+                    save_mh = *mhp;
+                  }
+              }
+            else if (GET_CODE (set_src) != REG)
+              update_regno_holds_mem (insn, set_src);
+
+            if (!is_push)
+              {
+                MEM_HOLDER *p = regno_holds_mem;
+                rtx store_pat;
+                
+	        for (; p < regno_holds_mem + FIRST_PSEUDO_REGISTER; p++)
+	          {
+	            if (p -> mem)
+	              {
+	                if (GET_CODE (p -> mem) == MEM
+	                    && true_dependence (set_dest, p -> mem))
+	                  {
+	                    p -> mem = 0;
+	                  }
+	              }
+	            if (p -> insn_store
+	                && (store_pat = PATTERN (p -> insn_store))
+	                && GET_CODE (SET_DEST (store_pat)) == MEM
+	                && true_dependence (set_dest,
+	                    		    SET_DEST (store_pat)))
+	              {
+	                /* insn_store is not valid any more */
+	                p -> insn_store = 0;
+	              }
+	          }
+	      }
+
+            if (mhp)
+              {
+                /* restore the relevant entry */
+		*mhp = save_mh;
+		mhp -> insn_store = insn;
+
+		/* if there was no load, we can consider this insn as if it is a
+		   load */
+		if (! mhp -> insn_load || GET_CODE (mhp -> insn_load) == NOTE)
+		  {
+		    mhp -> insn_load = insn;
+		    mhp -> mem = set_dest;
+		  }
+	      }
+              update_regno_holds_mem (insn, XEXP (set_dest, 0));
+          }
+        else
+          {
+            update_regno_holds_mem (insn, set_dest);
+            update_regno_holds_mem (insn, set_src);
+          }
+        return;
+      case CLOBBER:
+	set_dest = SET_DEST (pat);
+        if (GET_CODE (set_dest) == REG)
+          {
+            register int regno = REGNO (set_dest);
+            register int nregs = HARD_REGNO_NREGS (regno,
+                				   GET_MODE (set_dest));
+
+	    if (nregs == 1)
+	      {
+	        bzero (&regno_holds_mem[regno], sizeof (MEM_HOLDER));
+	        update_entries (set_dest);
+              }
+            else
+              /* memory holds more than one register. This is a simplification.
+                 Actually we should zero only those register entries which are
+                 relevant for nregs... */
+              bzero (regno_holds_mem, sizeof regno_holds_mem);
+          }
+        else if (GET_CODE (set_dest) == SUBREG)
+          {
+            regno = REGNO (SUBREG_REG (set_dest));
+            nregs = HARD_REGNO_NREGS (regno, GET_MODE (XEXP (set_dest, 0)));
+
+            mhp = &regno_holds_mem[regno];
+            for (; mhp < &regno_holds_mem[regno] + nregs; mhp++)
+              {
+                bzero (mhp, sizeof (MEM_HOLDER));
+              }
+            if (nregs == 1)
+              {
+                update_entries (XEXP (set_dest, 0));
+              }
+            else
+              {
+                /* memory holds more than one register. This is a simplification.
+                   Actually we should zero only those register entries which are
+                   relevant for nregs... */
+                bzero (regno_holds_mem, sizeof regno_holds_mem);
+              }
+            return;
+          }
+        else if (GET_CODE (set_dest) == MEM)
+          for (i = 0; i < FIRST_PSEUDO_REGISTER; i++)
+            {
+              /* the mem field indicates that this regno is no more valid for
+                 replacement in loads. Note that this regno might be valid for
+                 redundant store, or even replace loads with memory to which
+                 this reg was writing in the insn_store, and in such case we
+                 would like to reset the risc flags on all insns, from insn_load
+                 to insn_dead. This is why we don't reset here insn_load and
+                 insn_dead. */
+	      if (regno_holds_mem[i].mem
+	          && GET_CODE (regno_holds_mem[i].mem) == MEM
+	          && true_dependence (set_dest, regno_holds_mem[i].mem))
+                regno_holds_mem[i].mem = 0;
+            }
+        else
+          {
+            fprintf (stderr,
+                     "unpredicted case caused reset of regno_holds_mem:\n");
+            fprintf (stderr, "pattern:\n");
+            debug_rtx (pat);
+            fprintf (stderr, "insn:\n");
+	    debug_rtx (insn);
+	    bzero (regno_holds_mem, sizeof regno_holds_mem);
+	  }
+        return;
+      case CALL:
+        /* since we cannot know what writes to memory in the function call,
+           we must not use the information in regno_holds_mem anymore */
+
+	bzero (regno_holds_mem, sizeof regno_holds_mem);
+        return;
+      case PRE_DEC:
+      case PRE_INC:
+      case POST_DEC:
+      case POST_INC:
+        if (GET_CODE (XEXP (pat, 0)) == REG)
+          {
+            bzero (&regno_holds_mem[REGNO (XEXP (pat,0))], sizeof (MEM_HOLDER));
+	    update_entries (XEXP (pat, 0));
+          }
+        else
+          {
+            update_regno_holds_mem (insn, XEXP (pat, 0));
+          }
+        return;
+      case MEM:
+        /* there is a use of a memory in this insn, we cannot trust the
+           insn_store data anymore */
+        for (i = 0; i < FIRST_PSEUDO_REGISTER; i++)
+          {
+            regno_holds_mem[i].insn_store = 0;
+            if (regno_holds_mem[i].insn_load == NULL)
+              {
+                regno_holds_mem[i].insn_dead = 0;
+                regno_holds_mem[i].mem = NULL;
+              }
+          }
+        update_regno_holds_mem (insn, XEXP (pat, 0));
+        return;
+      case USE:
+        update_regno_holds_mem (insn, SET_DEST (pat));
+        return;
+    case HIGH:
+    case CONST_INT:
+    case CONST:
+    case CONST_DOUBLE:
+    case SYMBOL_REF:
+    case LABEL_REF:
+    case PC:
+    case CC0:
+    case REG:
+    /*case SUBREG:*/
+        /* do nothing */
+        return;
+  }  /* switch (GET_CODE (pat)) */
+
+  fmt = GET_RTX_FORMAT (code);
+  for (i = GET_RTX_LENGTH (code) - 1; i >= 0; i--)
+    if (fmt[i] == 'e')
+      {
+        if( XEXP (pat, i))
+          update_regno_holds_mem (insn, XEXP (pat, i));
+      }
+    else if (fmt[i] == 'E' || fmt[i] == 'V')
+      {
+	for (j = 0; j < XVECLEN (pat, i); j++)
+	  update_regno_holds_mem (insn, XVECEXP (pat, i, j));
+      }
+}  /* update_regno_holds_mem (rtx pat) */
+
+
+
+
+/* Invalidates entries of memory mentioning REG in their memories, and the
+   entry of the appropriate REG */
+
+static void
+update_entries (rtx reg)
+{
+  register MEM_HOLDER *mhp = regno_holds_mem;
+  register int regno = REGNO (reg);
+
+  for (; mhp < regno_holds_mem + FIRST_PSEUDO_REGISTER; mhp++)
+    {
+      if (mhp->mem && reg_overlap_mentioned_p (reg, mhp->mem))
+        {
+          if (mhp->insn_store && mhp->insn_store != mhp->insn_load)
+            {
+              mhp -> insn_load = mhp -> insn_store;
+              mhp -> mem = SET_DEST (PATTERN (mhp -> insn_load));
+              mhp -> insn_dead = 0;
+            }
+          else
+            bzero (mhp, sizeof (MEM_HOLDER));
+        }
+      if (mhp -> insn_store && GET_CODE (mhp -> insn_store) == INSN
+          /* insn_store can be deleted by redundant store elimination */
+          && reg_overlap_mentioned_p (reg, 
+                                      SET_DEST (PATTERN (mhp->insn_store))))
+        {
+          if (mhp->insn_load == mhp->insn_store)
+           {
+              bzero (mhp, sizeof (MEM_HOLDER));
+           }
+          else
+           {
+             mhp -> insn_store = 0;
+           }
+        }
+    }  /* for (; mhp < regno_holds_mem + FIRST_PSEUDO_REGISTER; mhp++) */
+}  /* update_entries (rtx reg) */
+
+
+
+/* for each regno found to be non-free (is used or set) from (and including)
+   FIRST, to LAST, clears the appropriate bit in HARD_REG_SET pointed to by
+   FREE. */
+   
+void
+find_free_regs_between (free, first, last)
+    HARD_REG_SET *free;
+    rtx first;
+    rtx last;
+
+{
+  rtx insn, pat;
+  char *funcname = "find_free_regs_between";
+  register int i;
+
+
+  if (! first)
+    abort ();
+  if (! last)
+    abort ();
+
+  insn = first;
+  while (insn
+         && insn != last)
+    {
+      if (GET_RTX_CLASS (GET_CODE (insn)) == 'i')
+        {
+          if (GET_CODE (insn) == CALL_INSN)
+            {
+              /* we should reset all regs clobbered by a call */
+              for (i = 0; i < FIRST_PSEUDO_REGISTER; i++)
+	        if (call_used_regs[i])
+		  CLEAR_HARD_REG_BIT (*free, i);
+	    }
+	  else  /* GET_RTX_CLASS (GET_CODE (insn)) != 'i' */
+	    {
+	      pat = PATTERN (insn);
+              for (i = 0; i < FIRST_PSEUDO_REGISTER; i++)
+		if (INSN_SETS_REGNO (insn, i)
+		    || INSN_USES_REGNO (insn, i))
+	          CLEAR_HARD_REG_BIT (*free, i);
+	    }
+        } /* if (GET_RTX_CLASS (GET_CODE (insn)) == 'i') */
+      insn = NEXT_INSN (insn);
+    }
+  if (insn != last)
+    fprintf (stderr, "%s (): didn't encounterd last!\n", funcname);
+  
+}
+
+/* removes a previous store of MEM if found, and returns INSN_UID of the insn
+   deleted. Otherwise returns 0. */
+static int
+remove_redundant_store (rtx mem, int block)
+{
+  rtx t_insn;
+  int regno;
+
+  for (regno = 0; regno < FIRST_PSEUDO_REGISTER; regno++)
+    if ((t_insn = regno_holds_mem[regno].insn_store)
+	&& GET_CODE (t_insn) == INSN
+        && rtx_equal_p (SET_DEST (PATTERN (t_insn)), mem))
+      {
+        if (basic_block_head[block] == t_insn)
+          basic_block_head[block] = NEXT_INSN (t_insn);
+        PUT_CODE (t_insn, NOTE);
+        NOTE_LINE_NUMBER (t_insn) = NOTE_INSN_DELETED;
+        NOTE_SOURCE_FILE (t_insn) = 0;
+
+        /* if the insn we have just deleted, was preceded with one or two risc
+           additions (i.e. memory_simplify added insns before it), and they are
+           not used for anything else, remove them as well */
+        if (RTX_IS_RISC_P (PREV_INSN (t_insn)))
+          {
+            PUT_CODE (PREV_INSN (t_insn), NOTE);
+            NOTE_LINE_NUMBER (PREV_INSN (t_insn)) = NOTE_INSN_DELETED;
+            NOTE_SOURCE_FILE (PREV_INSN (t_insn)) = 0;
+            if (RTX_IS_RISC_P (PREV_INSN (PREV_INSN (t_insn))))
+              {
+                PUT_CODE (PREV_INSN (PREV_INSN (t_insn)), NOTE);
+                NOTE_LINE_NUMBER (PREV_INSN (PREV_INSN (t_insn)))
+                					    = NOTE_INSN_DELETED;
+                NOTE_SOURCE_FILE (PREV_INSN (PREV_INSN (t_insn))) = 0;
+              }
+          }
+           
+        return INSN_UID (t_insn);
+      }
+  return 0;
+}  /* remove_redundant_store (rtx mem) */
+
+/* intel2 - end */
+/* intel1 */
+
+/*
+  Try to eliminate unnecessary reg to reg moves, and also
+  if the destination is a register try to use that register
+  as one of the sources.  
+
+  EXAMPLE:
+
+(insn 618 614 616 (set (reg:SI %eax)
+        (mem/s:SI (plus:SI (mult:SI (reg/v:SI %ebx)
+                    (const_int 4))
+                (reg:SI %esi)))) -1 (nil)
+    (nil))
+
+(insn 616 618 59 (set (reg:SI %esi)
+        (mem:SI (plus:SI (reg:SI %esp)
+                (const_int 36)))) -1 (nil)
+    (nil))
+
+(insn:HI 59 616 60 (set (reg:SI %eax)
+        (ior:SI (reg:SI %eax)
+            (mem/s:SI (plus:SI (mult:SI (reg/v:SI %ebx)
+                        (const_int 4))
+                    (reg:SI %esi))))) 105 {iorsi3} (nil)
+    (nil))
+
+(insn 60 59 620 (set (reg:SI %eax)
+        (not:SI (reg:SI %eax))) 130 {one_cmplsi2} (insn_list 59 (nil))
+        (nil))
+
+(insn 620 60 61 (set (reg/v:SI %ecx)
+        (reg:SI %eax)) -1 (nil)
+    (expr_list:REG_DEAD (reg:SI %eax)
+    (nil)))
+
+WILL BECOME:
+
+(insn 618 614 616 (set (reg:SI %ecx)
+        (mem/s:SI (plus:SI (mult:SI (reg/v:SI %ebx)
+                    (const_int 4))
+                (reg:SI %esi)))) -1 (nil)
+    (nil))
+
+(insn 616 618 59 (set (reg:SI %esi)
+        (mem:SI (plus:SI (reg:SI %esp)
+                (const_int 36)))) -1 (nil)
+    (nil))
+
+(insn:HI 59 616 60 (set (reg:SI %ecx)
+        (ior:SI (reg:SI %ecx)
+            (mem/s:SI (plus:SI (mult:SI (reg/v:SI %ebx)
+                        (const_int 4))
+                    (reg:SI %esi))))) 105 {iorsi3} (nil)
+    (nil))
+
+(insn 60 59 620 (set (reg:SI %ecx)
+        (not:SI (reg:SI %ecx))) 130 {one_cmplsi2} (insn_list 59 (nil))
+        (nil))
+
+(note 620 60 61 "" NOTE_INSN_DELETED)
+
+
+The trigger for the optimization is:
+
+(insn 620 60 61 (set (reg/v:SI %ecx)
+        (reg:SI %eax)) -1 (nil)
+    (expr_list:REG_DEAD (reg:SI %eax)
+    (nil)))
+
+*/
+void
+reg_to_reg_copy_opt (f, file)
+     rtx f;
+     FILE *file;
+{
+  rtx this_insn, regx, note, src;
+  int regno, success, length, i;
+  char * fmt;
+
+  if (file)
+    {
+      fprintf (file, "\n\ndoing reg to reg copy opt\n");
+    }
+  hard_reg_flow_analysis (f, NULL, 1);
+  this_insn = f;
+  while (this_insn)
+    {
+      if (GET_CODE (this_insn) == INSN 
+          && GET_CODE (PATTERN (this_insn)) == SET
+          && GET_CODE (SET_DEST (PATTERN (this_insn))) == REG
+          && GET_CODE (SET_SRC (PATTERN (this_insn))) == REG
+          && REGNO (SET_SRC (PATTERN (this_insn))) 
+             != REGNO (SET_DEST (PATTERN (this_insn))) 
+          && GET_MODE (SET_SRC (PATTERN (this_insn))) 
+             == GET_MODE (SET_DEST (PATTERN (this_insn))) 
+          && find_regno_note (this_insn, REG_DEAD, 
+                              REGNO (SET_SRC (PATTERN (this_insn))))
+         )
+        {
+          success = try_backwards_replace (SET_DEST (PATTERN (this_insn)), 
+                                 SET_SRC (PATTERN (this_insn)),
+                                 this_insn, 1, file);
+          if (!success)
+            {
+               success = try_forwards_replace (SET_DEST (PATTERN (this_insn)), 
+                                 SET_SRC (PATTERN (this_insn)),
+                                 this_insn, file);
+            }
+        }
+      else if (GET_CODE (this_insn) == INSN 
+               && GET_CODE (PATTERN (this_insn)) == SET
+               && GET_CODE (SET_DEST (PATTERN (this_insn))) == REG
+               && GET_CODE (SET_SRC (PATTERN (this_insn))) == SUBREG
+               && REGNO (SET_DEST (PATTERN (this_insn))) 
+                  != REGNO (SUBREG_REG (SET_SRC (PATTERN (this_insn))))
+               && SUBREG_WORD (SET_SRC (PATTERN (this_insn))) == 0
+               && GET_MODE (SET_SRC (PATTERN (this_insn))) 
+                  == GET_MODE (SET_DEST (PATTERN (this_insn))) 
+               && (note = find_regno_note (this_insn, REG_DEAD, 
+                                   REGNO (SUBREG_REG (SET_SRC (PATTERN (this_insn))))))
+               && rtx_equal_p (XEXP (note, 0), 
+                               SUBREG_REG (SET_SRC (PATTERN (this_insn))))
+               && HARD_REGNO_NREGS (REGNO (SET_DEST (PATTERN (this_insn))),
+            		            GET_MODE (SUBREG_REG (SET_SRC (PATTERN (this_insn)))))
+                   ==
+                  HARD_REGNO_NREGS (REGNO (SET_DEST (PATTERN (this_insn))),
+            			    GET_MODE (SET_DEST (PATTERN (this_insn))))
+               && HARD_REGNO_NREGS (REGNO (SET_DEST (PATTERN (this_insn))),
+            			    GET_MODE (SET_DEST (PATTERN (this_insn))))
+                   == 1
+               && HARD_REGNO_MODE_OK (REGNO (SET_DEST (PATTERN (this_insn))) ,
+                                      GET_MODE (SUBREG_REG (SET_SRC (PATTERN (this_insn)))))
+              )
+        {
+          regx = gen_rtx (REG, 
+                          GET_MODE (SUBREG_REG (SET_SRC (PATTERN (this_insn)))),
+                          REGNO (SET_DEST (PATTERN (this_insn))));
+          success 
+           = try_backwards_replace (regx,
+                                 SUBREG_REG (SET_SRC (PATTERN (this_insn))),
+                                 this_insn, 1, file);
+          if (!success)
+            {
+              success 
+               = try_forwards_replace (SET_DEST (PATTERN (this_insn)),
+                                 SET_SRC (PATTERN (this_insn)),
+                                 this_insn, file);
+            }
+        }
+      else if (GET_CODE (this_insn) == INSN 
+          && GET_CODE (PATTERN (this_insn)) == SET
+          && GET_CODE (SET_DEST (PATTERN (this_insn))) == REG
+          && GET_CODE (SET_SRC (PATTERN (this_insn))) != MEM
+          && GET_CODE (SET_SRC (PATTERN (this_insn))) != SUBREG
+          && !reg_overlap_mentioned_p (SET_DEST (PATTERN (this_insn)),
+                                       SET_SRC (PATTERN (this_insn)))
+          )
+        {
+          src = SET_SRC (PATTERN (this_insn));
+          fmt = GET_RTX_FORMAT (GET_CODE (src));
+          length = GET_RTX_LENGTH (GET_CODE (src));
+          for (i=0; i<length; i++)
+            {
+              if (fmt[i] == 'e' 
+                  && GET_CODE (XEXP (src, i)) == SUBREG)
+                {  /* Makes matters too complex.  */
+                  return;
+                }
+            }
+          for (i=0; i<length; i++)
+            {
+              if (fmt[i] == 'e' 
+                  && GET_CODE (XEXP (src, i)) == REG
+                  && (note = find_regno_note (this_insn, REG_DEAD,
+                                              REGNO (XEXP (src, i))))
+                  && rtx_equal_p (XEXP (src, i), XEXP (note, 0))
+                  )
+                { /* One of the sources dies in this insn -
+                     see if the destination register can be used
+                     to replace that register.  This has a chance
+                     of producing better code e.g. reg1 <- reg1 AND reg3
+                     produces more efficient code than 
+                     reg1 <- reg2 AND reg3.  */
+                  rtx regx, regy;
+                  regy = XEXP (src, i);
+                  regx = SET_DEST (PATTERN (this_insn));
+                  if (reg_overlap_mentioned_p (regx, PATTERN (this_insn)))
+                    {
+                      break;
+                    }
+                  if (GET_MODE (regx) != GET_MODE (regy))
+                    {
+                      if (HARD_REGNO_NREGS (REGNO (regx), GET_MODE (regy)) != 1
+                          || 
+                          !(HARD_REGNO_MODE_OK (REGNO (regx), GET_MODE (regy))))
+                        {
+                          continue;
+                        }
+                      regx = gen_rtx (REG, GET_MODE (regy), REGNO (regx)); 
+                    }
+                  if (try_backwards_replace (regx, regy, this_insn, 0, file))
+                    {
+                      remove_note (this_insn, note);
+                      break; /* Since now the dest reg is 
+                                mentioned in the src.  */
+                    }
+                }
+            }
+
+        }
+      this_insn = NEXT_INSN (this_insn);
+    }
+  if (file)
+    {
+      fprintf (file, "\n");
+    }
+}
+
+/*
+  insn is of the form
+     regx <- regy (regy dead)
+   or
+     regx <- SUBREG (regy) (regy dead)
+   or
+     regx <- OP (regy, ...) (regy dead)
+   
+  Search backwards for last previous setting of regy in which the 
+  setting of regy can be replaced with regx.  If it can then
+  do the replacement and then if delete_flag is set delete insn.  
+*/
+
+static
+int
+try_backwards_replace (regx, regy, insn, delete_flag, file)
+  rtx regx, regy, insn;
+  FILE *file;
+{
+  rtx this_insn, set_insn, stop_insn;
+  int stop_replacement = 0;
+  int found = 0, insn_code_number, not_yet_recoged;
+  
+  
+  if (file)
+    {
+      fprintf (file, "\ninsn %d reg%d <- reg%d (reg%d dead) (try backwards)\n", 
+      INSN_UID(insn), REGNO (regx), REGNO (regy), REGNO(regy));
+    }
+  this_insn = prev_nonnote_insn (insn);
+  /* Find the first previous insn in the block that sets regy and in
+     which regy can be replaced with regx */
+  while (!found && this_insn 
+         && !(GET_CODE (this_insn) == CODE_LABEL 
+              || GET_CODE (this_insn) == CALL_INSN
+              || GET_CODE (this_insn) == JUMP_INSN))
+    {
+      if (GET_CODE (this_insn) == INSN)
+        {
+          if (GET_CODE (PATTERN (this_insn)) != SET)
+            {
+              return (0);
+            }
+          if (GET_CODE (SET_DEST (PATTERN (this_insn))) == REG)
+            {
+              if (REGNO (regx) == REGNO (SET_DEST (PATTERN (this_insn))))
+                {
+                  return (0);
+                }
+              else if (REGNO (regy) == REGNO (SET_DEST (PATTERN (this_insn))))
+                {
+                  if (GET_MODE (regy) 
+                       == GET_MODE (SET_DEST (PATTERN (this_insn))))
+                    {
+#ifdef REGISTER_CONSTRAINTS
+                      if (INSN_CODE (this_insn) == -1)
+                        {
+                          INSN_CODE (this_insn) 
+                            = recog (PATTERN (this_insn), this_insn, 0);
+                        }
+#endif
+                      SET_DEST (PATTERN (this_insn)) = regx;
+#ifdef REGISTER_CONSTRAINTS
+
+	              if ((insn_code_number
+	                   = recog (PATTERN (this_insn), this_insn, 0)) < 0
+                          || (INSN_CODE (this_insn) != -1
+                              && insn_code_number != INSN_CODE (this_insn)))
+	                {/* Need to have the same code number since 
+	                    constraints are sometimes more lax than 
+	                    predicates */
+		          SET_DEST (PATTERN (this_insn)) = regy;
+		          stop_replacement = 1;
+		        }
+		        else
+	                {
+	                  INSN_CODE (this_insn) = insn_code_number;
+		          insn_extract (this_insn);
+		          if(!constrain_operands (INSN_CODE (this_insn), 1))
+	                    {
+		              /* restore the previous situation */
+	  	              SET_DEST (PATTERN (this_insn)) = regy;
+	                      /*INSN_CODE (this_insn) 
+	                       = recog (PATTERN (this_insn), this_insn, 0);*/
+		              stop_replacement = 1;
+ 		            }
+		        }
+        
+#endif
+                      if (!stop_replacement)
+                        {
+                          found = 1;
+                          set_insn = this_insn;
+                        }
+                    }
+                  else
+                    {
+                      return (0);
+                    }
+                }
+            }
+          else if (reg_overlap_mentioned_p (regx, SET_DEST (PATTERN (this_insn))))
+            {
+              return (0);
+            }
+          if (!found
+              && reg_overlap_mentioned_p (regx, SET_SRC (PATTERN (this_insn))))
+            {
+              return (0);
+            }
+        }
+      if (!found)
+        {
+          stop_replacement = 0;
+          this_insn = prev_nonnote_insn (this_insn);
+        }
+    }
+  if (found)
+    {/* We have found the insn that last sets regy and successfully 
+        replaced regx as the dest of that insn.  
+        In all insns between set_insn and insn replace regy with regx.  */
+      stop_replacement = 0;
+      this_insn = next_nonnote_insn (set_insn);
+      init_undo_buf ();
+      stop_insn = next_nonnote_insn (insn);
+      while (this_insn != stop_insn && !stop_replacement)
+        {
+#ifdef REGISTER_CONSTRAINTS
+          if (INSN_CODE (this_insn) == -1)
+            {
+              INSN_CODE (this_insn) 
+                = recog (PATTERN (this_insn), this_insn, 0);
+            }
+#endif
+          subst_in_insn (this_insn, PATTERN (this_insn), regy, regx, 0, 0);
+          if (reg_set_p (regy, this_insn)
+              || reg_overlap_mentioned_p (regy, PATTERN (this_insn)))
+            { /* regy was used in some other mode - fail */
+              stop_replacement = 1;
+            }
+#ifdef REGISTER_CONSTRAINTS
+          if (stop_replacement
+              ||
+              (insn_code_number
+                = recog (PATTERN (this_insn), this_insn, 0)) < 0
+              || (INSN_CODE (this_insn) != -1
+                  && insn_code_number != INSN_CODE (this_insn)))
+            {/* Need to have the same code number since constraints
+                 are sometimes more lax than predicates */
+              stop_replacement = 1;
+            }
+          else
+            {
+              INSN_CODE (this_insn) = insn_code_number;
+              insn_extract (this_insn);
+	      if(!constrain_operands (INSN_CODE (this_insn), 1))
+	        {
+	          stop_replacement = 1;
+	        }
+            }
+#endif
+          this_insn = next_nonnote_insn ( this_insn);
+        }
+        
+      if (stop_replacement)
+        { /* A replacement was unsuccessful - undo all of the replacements */
+          SET_DEST (PATTERN (set_insn)) = regy;
+          /*INSN_CODE (this_insn) 
+            = recog (PATTERN (this_insn), this_insn, 0);*/
+          this_insn = next_nonnote_insn (set_insn);
+          loop_undo_all ();
+          /*while (this_insn != insn)
+            {
+              INSN_CODE (this_insn) 
+                = recog (PATTERN (this_insn), this_insn, 0); 
+              this_insn = next_nonnote_insn (this_insn);
+            }*/
+          return (0);
+        }
+      else 
+        { 
+	  if (file)
+	    {
+	      fprintf (file, "replaced dest reg%d of insn %d with reg%d\n",
+	        REGNO (regy), INSN_UID (set_insn), REGNO (regx));
+	      fprintf (file, " in insns %d through %d replaced reg%d with reg%d\n",
+	        INSN_UID (next_nonnote_insn (set_insn)),
+	        INSN_UID (insn), 
+	        REGNO (regy), REGNO (regx));
+	    }
+          if (delete_flag)
+            {/* Delete insn */
+              PUT_CODE (insn, NOTE);
+	      NOTE_LINE_NUMBER (insn) = NOTE_INSN_DELETED;
+	      NOTE_SOURCE_FILE (insn) = 0;
+	      if (file)
+	        {
+	          fprintf (file, " deleted insn %d\n", INSN_UID (insn));
+	        }
+	    }
+          return (1);
+        }
+    }
+  return (0);
+}
+
+
+/*
+  insn is of the form
+     regx <- regy (regy dead)
+   or
+     regx <- SUBREG (regy) (regy dead)
+   
+  Search forwards for next insn in which the regx is dead.
+  Try to replace all uses of regx with regy in those insns
+  and if successful then delete insn.  
+*/
+
+static
+int
+try_forwards_replace (regx, regy, insn, file)
+  rtx regx, regy, insn;
+  FILE *file;
+{
+  rtx this_insn, dead_insn, dead_note, stop_insn;
+  int stop_replacement = 0;
+  int found = 0, insn_code_number;
+  
+  
+  if (file)
+    {
+      if (GET_CODE (regy) == REG )
+        fprintf (file, "\ninsn %d reg%d <- reg%d (reg%d dead) (try forwards)\n", 
+        INSN_UID(insn), REGNO (regx), REGNO (regy), REGNO(regy));
+      else
+        fprintf (file, "\ninsn %d reg%d <- reg%d (reg%d dead) (try forwards)\n", 
+        INSN_UID(insn), REGNO (regx), 
+        REGNO (SUBREG_REG (regy)), 
+        REGNO (SUBREG_REG (regy)));
+    }
+  this_insn = next_nonnote_insn (insn);
+  /* Find the next insn in the block where regx dies */
+  while (!found && this_insn 
+         && !(GET_CODE (this_insn) == CODE_LABEL 
+              || GET_CODE (this_insn) == CALL_INSN
+              || GET_CODE (this_insn) == JUMP_INSN))
+    {
+      if (GET_CODE (this_insn) == INSN)
+        {
+          if (GET_CODE (PATTERN (insn)) == USE
+              && reg_overlap_mentioned_p (regx, SET_DEST (PATTERN (insn))))
+            {
+              return (0);
+            }
+          if (reg_set_p (regy, this_insn))
+            {
+              return (0);
+            }
+          else if ((dead_note 
+                    = find_regno_note (this_insn, REG_DEAD, REGNO (regx)))
+                   && rtx_equal_p (XEXP (dead_note, 0), regx))
+            {
+              found = 1;
+              dead_insn = this_insn;
+            }
+        }
+      if (!found)
+        {
+          this_insn = next_nonnote_insn (this_insn);
+        }
+    }
+  if (found)
+    {/* We have found the insn where regx dies.  */
+      stop_replacement = 0;
+      this_insn = next_nonnote_insn (insn);
+      init_undo_buf ();
+      stop_insn = next_nonnote_insn (dead_insn);
+      while (this_insn != stop_insn && !stop_replacement)
+        {
+#ifdef REGISTER_CONSTRAINTS
+          if (INSN_CODE (this_insn) == -1)
+            {
+              INSN_CODE (this_insn) 
+                = recog (PATTERN (this_insn), this_insn, 0);
+            }
+#endif
+          subst_in_insn (this_insn, PATTERN (this_insn), regx, regy, 0, 0);
+          if (reg_set_p (regx, this_insn)
+              || reg_overlap_mentioned_p (regx, PATTERN (this_insn)))
+            { /* regx is used in some other mode - fail.  */
+              if (file)
+                {
+                  fprintf (file, "fail insn %d reg %d still mentioned\n",
+                  INSN_UID (this_insn), REGNO (regx));
+                  tdebug_rtx (this_insn, file);
+                }
+              stop_replacement = 1;
+            }
+#ifdef REGISTER_CONSTRAINTS
+          if (stop_replacement
+              ||
+              (insn_code_number
+                = recog (PATTERN (this_insn), this_insn, 0)) < 0
+              || (INSN_CODE (this_insn) != -1
+                  && insn_code_number != INSN_CODE (this_insn)))
+            { /* Need to have the same code number since constraints
+                 are sometimes more lax than predicates */
+              if (file)
+                {
+                  fprintf (file, "fail insn %d new_recog %d old_recog %d\n",
+                  INSN_UID (this_insn), insn_code_number, INSN_CODE (this_insn));
+                }
+              stop_replacement = 1;
+            }
+          else
+            {
+              INSN_CODE (this_insn) = insn_code_number;
+              insn_extract (this_insn);
+	      if(!constrain_operands (INSN_CODE (this_insn), 1))
+	        {
+	          stop_replacement = 1;
+	        }
+            }
+#endif
+          this_insn = next_nonnote_insn ( this_insn);
+        }
+        
+      if (stop_replacement)
+        { /* A replacement was unsuccessful - undo all of the replacements */
+          this_insn = next_nonnote_insn (insn);
+          loop_undo_all ();
+          stop_insn = next_nonnote_insn (dead_insn);
+          /*while (this_insn != stop_insn)
+            {
+              INSN_CODE (this_insn) 
+                 = recog (PATTERN (this_insn), this_insn, 0); 
+              this_insn = next_nonnote_insn (this_insn);
+            }*/
+          return (0);
+        }
+      else
+        { /* Delete insn */
+          PUT_CODE (insn, NOTE);
+	  NOTE_LINE_NUMBER (insn) = NOTE_INSN_DELETED;
+	  NOTE_SOURCE_FILE (insn) = 0;
+	  XEXP (dead_note, 0) = regy;
+	  if (file)
+	    {
+	      fprintf (file, " in insns %d through %d replaced reg%d with reg%d\n",
+		       INSN_UID (next_nonnote_insn (insn)),
+		       INSN_UID (dead_insn), 
+		       REGNO (regx), 
+		       GET_CODE (regy) == REG 
+		         ? REGNO (regy)
+		         : REGNO (SUBREG_REG (regy)));
+	      fprintf (file, " deleted insn %d\n", INSN_UID (insn));
+	    }
+          return (1);
+        }
+    }
+  return (0);
 }
